{NOBS Technology}
unit logotpu;
interface
procedure logo(nama : string; x,y : integer);
procedure logoawal(nama : string; x,y : integer;lama : integer);
procedure loadlogos(nama : string; x,y : integer);

implementation
uses crt,modex,pal256tp;
type
  TPaletteEntry = record
    B: Byte;
    G: Byte;
    R: Byte;
    Flags: Byte;
  end;
  ArrayPal256 = array[0..255] of TPaletteEntry;
  TBitmapFileHeader = record
    bfType: Word;
    bfSize: Longint;
    bfReserved1: Word;
    bfReserved2: Word;
    bfOffBits: Longint;
    biSize: Longint;
    biWidth: Longint;
    biHeight: Longint;
    biPlanes: Word;
    biBitCount: Word;
    biCompression: Longint;
    biSizeImage: Longint;
    biXPelsPerMeter: Longint;
    biYPelsPerMeter: Longint;
    biClrUsed: Longint;
    biClrImportant: Longint;
  end;
  arrayheaderbmp = array [0..53] of byte;
  var pal256 : ArrayPal256;
      header : arrayheaderbmp;
      i : integer;
      pal : Palette256;
      tempRGB : RGB;

procedure loadbmp256(pil : boolean;Bitmapname : string; x,y : integer;var pal256 : ArrayPal256;var header : arrayheaderbmp);
var bfh : TBitmapFileHeader;
    FileOpen : boolean;
    F : File;
    C,i : byte;
    xt,yt : integer;
    Lin8 : array [1..640] of byte;
    pal : Palette256;
    width : integer;

function OpenFile : Boolean;
  begin
    FileOpen := False;
    OpenFile := False;
    Assign(F, BitmapName);
    Reset(F, 1);
    if IoResult <> 0 then Exit;
    FileOpen := True;
    OpenFile := True;
  end;

  function CloseFile : Boolean;
  begin
    FileOpen := False;
    CloseFile := False;
    Close(F);
    if IoResult <> 0 then Exit;
    CloseFile := True;
  end;

begin
     if Openfile then
     begin
          BlockRead(F, header, SizeOf(bfh));
          Reset(F,1);
          BlockRead(F, bfh, SizeOf(bfh));
          width := bfh.biWidth;
          if (bfh.bibitcount = 8) and (bfh.biWidth<=640) and (bfh.biHeight<=480) then
          begin
               BlockRead(F, Pal256, SizeOf(Pal256));
               for C := 0 to 255 do
               begin
                    Pal256[C].R := Pal256[C].R div 4;
                    Pal256[C].G := Pal256[C].G div 4;
                    Pal256[C].B := Pal256[C].B div 4;
               end;
               for i := 0 to 255 do
               begin
                    Pal[i].Red  := Pal256[i].R;
                    Pal[i].Green:= Pal256[i].G;
                    Pal[i].Blue := Pal256[i].B;
               end;
               SetPalette(Pal);

               if (bfh.biWidth mod 4) <> 0 then
                  while (bfh.biWidth mod 4) <> 0 do Inc(bfh.biWidth);
               if pil  then
               for yt := bfh.biHeight-1 downto 0 do
               begin
                    BlockRead(F, Lin8,bfh.biWidth);
                    for xt := 1 to Width-1 do
                    begin
                         {if (x+xt)<640 then}
                         Putpixel256(x+xt,y+yt,Lin8[xt]);
                    end;
               end
               else
               if not pil then
               for yt := bfh.biHeight-1 downto 0 do
               begin
                    BlockRead(F, Lin8,bfh.biWidth);
                    for xt := 1 to Width do
                    begin
                         Pset(x+xt,y+yt,Lin8[xt]);
                    end;
               end;

          end;
          closefile;
     end
     else
     closefile;
end;
procedure logo(nama : string; x,y : integer);
begin
      if InitVesa then
      begin
           InitModeVesa;
           loadbmp256(true,nama,x,y,pal256,header);

      end;
      for i := 0 to 255 do
               begin
                    Pal[i].Red  := Pal256[i].R;
                    Pal[i].Green:= Pal256[i].G;
                    Pal[i].Blue := Pal256[i].B;
               end;

      repeat
      tempRGB := Pal[header[50]];
      for i := header[50]  to 254 do
      begin
           Pal[i] := Pal[i+1];
      end;
               Pal[255] := tempRGB;
               SetPalette(Pal);
               delay(100);
      until keypressed;
      readkey;

      CloseGraph;
end;
procedure loadlogos(nama : string; x,y : integer);
begin
      if InitVesa then
      begin
           InitModeVesa;
           loadbmp256(true,nama,x,y,pal256,header);

      end;
end;

procedure logoawal(nama : string; x,y : integer;lama : integer);
var j : integer;
begin
      if InitVesa then
      begin
           InitModeVesa;
           loadbmp256(true,nama,x,y,pal256,header);

      end;
      for i := 0 to 255 do
               begin
                    Pal[i].Red  := Pal256[i].R;
                    Pal[i].Green:= Pal256[i].G;
                    Pal[i].Blue := Pal256[i].B;
               end;

      for j := 0 to lama do
      begin
      tempRGB := Pal[header[50]];
      for i := header[50]  to 254 do
      begin
           Pal[i] := Pal[i+1];
      end;
               Pal[255] := tempRGB;
               SetPalette(Pal);
               delay(120);
      end;

end;

end.

     {false
     InitMode13;
      loadbmp256(false,'coba2.bmp',100,100,pal256,header);
           for i := 0 to 255 do
           begin
                Pal[i].Red  := Pal256[i].R;
                Pal[i].Green:= Pal256[i].G;
                Pal[i].Blue := Pal256[i].B;
           end;
           SetPalette(Pal);
      }
