{NOBS Technology}
unit painttpu;
interface
uses crt,graph,mousetpu;
procedure programpaint;
implementation
procedure kotak(x1,y1,x2,y2,warna,fills : integer; diisikah : boolean);
{procedure untuk menggambar persegi panjang dengan koordinat x1,y1,x2,y2
warna menyatakan warna pinggir, fills warna kotak secara keseluruhan, diisikkan
bernilai true jika kotak berwarna (dalam hal ini warna fills) false jika tidak}
begin
   if diisikah then
   begin
     setfillstyle(1,fills); {untuk warna fills }
     bar(x1,y1,x2,y2);     {persegi panjang dengan warna fills menutupi pesrsegipanjang}
   end;
    setcolor(warna);       {warna pinngir}
    rectangle(x1,y1,x2,y2); {persegi panjang biasa}
end;

procedure kotak_menu;{menggambar menu}
var i,j : byte;
    x,y : integer;
begin
     {keseluruhan}
     kotak(0,0,639,479,7,8,true);
     {area gambar}
     kotak(50,30,600,450,0,0,true);
     {exit}
     kotak(615,5,635,25,7,8,true);
     setcolor(0);           {warna hitam}
     SetLineStyle(0, 0, 3); {0 pertama menyatakan jenis garis, 0 kedua menyakan pattern dan 3
                            menyatakan ketebalan dari garis }
     line(620,8,630,22); {menggambar X}
     line(620,22,630,8); {menggambar X}
     setcolor(0);
     line(615,25,635,25); {menggambar X}
     line(635,5,635,25);  {menggambar X}
     SetLineStyle(0, 0, 1); {ketebalan dari garis 3}
     {menu samping yaitu garis,kotak,F,pensil}
     for i := 1 to 4 do
     begin
         kotak(10,80+(i*20),35,100+(i*20)-1,0,7,true);
     end;
     {menu bawah untuk pemilihan warna dari warna ke-0(hitam) s/d ke_15(putih)}
     for i := 0 to 15 do
     begin
          kotak(100+(i*20),455,120+(i*20)-1,475,0,i,true);
     end;
     {menu tipe garis}
     {0-------- 1 - - - - 2 -  -   - }
     for i := 0 to 2 do
     begin
          kotak(10,300+(i*20),35,320+(i*20)-1,0,7,true);
          setcolor(4);
          setlinestyle(i,0,1);
          line(15,320+(i*20)-10,30,320+(i*20)-10);
          setlinestyle(0,0,1);
     end;
     {menu tebal garis}
     for i := 0 to 1 do
     begin
          kotak(10,400+(i*20),35,420+(i*20)-1,0,7,true);
          setcolor(4);
          setlinestyle(0,0,1+2*i);
          line(15,420+(i*20)-10,30,420+(i*20)-10);
          setlinestyle(0,0,1);
     end;
     kotak(5,455,45,475,1,1,true);{menu bawah kiri}
     kotak(100+(1*20),455,120+(1*20)-1,475,14,14,false);{menu bawah yg dipilih pertamakali}
     kotak(10,80+(1*20),35,100+(1*20)-1,14,14,false);{menu samping yg dipilih pertamakali}
     kotak(10,400+(0*20),35,420+(0*20)-1,14,14,false); {menu tebal garis dipilih pertamakali}
     kotak(10,300+(0*20),35,320+(0*20)-1,14,14,false) ;{menu jenis garis dipilih pertamakali}
     setlinestyle(0,0,3);
     setcolor(1);
     line(17,116,29,104);       {menggambar garis pada menu samping}
     settextstyle(0,0,2);
     outtextxy(17,143,'F');     {menggambar F untuk  floodfill}
     line(23,176,23,164);       {menggambar pensil}
     setlinestyle(0,0,1);
     rectangle(15,136,30,124);  {menggambar kotak}

end;
procedure proses;

var  klik : boolean;
    x1,y1,x2,y2 : integer;
    m : byte;
    x,y : integer;
    warna_f, menu_b,i,menu_s : integer;
    menu_g,tebal_g : integer;
begin
   menu_g := 0; {jenis garis 0,1,2}
   tebal_g := 1;{tebal garis hanya ada 1 dan 3}
   menu_b := 1; {warna dari 0..15}
   menu_s := 1; {menu samping 1 : garis, 2 : kotak, 3 : floodfill, 4 : pensil}
   warna_f := 1; {warna floodfill}

   mouseon;
   repeat
     m := 0;
     repeat
           mouselepas(klik);
           mousetekan(klik);    {klik=false berarti tombol kiri jika tidak kanan}
     until tikus.tombolmana<>0; {ada tombol yang ditekan }
   if mouseinkotak(50,30,600,450) then {mouse di area gambar}
   begin
     SetLineStyle(menu_g, 0, tebal_g); {atur jenis dan tebal garis}
     setwritemode(xorput);             {penulisan dengan metode xor jika sama 2x maka hilang}
     SetViewPort(50,30,600,450,true);  {daerah gambar yang hanya bisa berubah dengan koordinat di samping}
     posisimouse(x1,y1);               {cari lokasi mouse pertamakali diklik}
     x1 := x1-50;                      {karena  setviewport(50,30,..) maka koordinat 50,30 = 0,0 sekarang  jadi x1-50)}
     y1 := y1-30;                      {y menjadi y1-30 dimana y1 adalah koordinat antara 0..480}
     repeat
           mouselepas(klik);            {mouse ditunggu dilepas}
           x := x2;                     {x adalah penampung sementara x2 yaitu posisi mouse jika berubah/palin akhir}
           y := y2;                     {y adalah penampung sementara y2 yaitu posisi mouse jika berubah/palin akhir}
           posisimouse(x2,y2);          {dapatkan posisimouse dari prosedur di mousetpu}
           x2 := x2-50;                 {idem karen setviewport(30,50,..}
           y2 := y2-30;                 {idem karen setviewport(30,50,..}
           if ((x=x2) and (y=y2)) and (m =1) then   {mouse tidak berubah}
           begin
           m := 2;
           mouseoff;                    {mouse disembunyikan gara tidak menimpa gambar}
           setwritemode(xorput);        {metode xor bila ada yang sama maka dihapus jika tidak digambar}
           case menu_s of
           1 :  line(x1,y1,x,y);        {gambar garis}
           2 :  rectangle(x1,y1,x,y);   {gambar kotak}
           end;
           mouseon;                     {mouse dimunculkan lagi}
           end;
           if ((x<>x2) or (y<>y2)) then  {mouse berubah}
           begin
           if m = 2 then                {tanda beleum bergerak sebelumnya}
           begin
                mouseoff;                {mouse disembunyikan}
                setwritemode(xorput);
                case menu_s of
                     1 :  line(x1,y1,x,y);      {garis}
                     2 :  rectangle(x1,y1,x,y); {kotak}
                     4 : begin
                           setwritemode(copyput); {metode copyput langsung digambar di layar}
                           line(x2,y2,x,y);      {titik}
                           setwritemode(xorput);
                         end;
                end;
           mouseon;      {MOUSE MUNCUL}
           end;
           m := 1;      {tanda mouse sudah bergerak}
           mouseoff;
           setwritemode(xorput);
           case menu_s of
                     1 :  begin
                          line(x1,y1,x,y);  {hilangkan gambar}
                          line(x1,y1,x,y);  {gambar ulang}
                          end;
                     2 :  begin
                          rectangle(x1,y1,x,y); {hilangkan gambar}
                          rectangle(x1,y1,x,y); {gambar ulang}
                          end;

                end;

           mouseon; {munclkan mouse}
           end;
     until tikus.tombolmana<>0; {mouse diklik}
     posisimouse(x2,y2);
     x2 := x2-50;
     y2 := y2-30;
     mouseoff;
     setwritemode(copyput);           {mode gambar digambar langsung ke layar}
     case menu_s of
          1 :  line(x1,y1,x2,y2);      {garis}
          2 :  rectangle(x1,y1,x2,y2); {kotak}
          3 :  begin
                setfillstyle(1,warna_f);
                floodfill(x2,y2,menu_b);  {floodfill dengan batas warna menu_b}
               end;

     end;
     mouseon;
     SetViewPort(0,0,getmaxx,getmaxy,true); {area gambar 0,0,640,480)}
   end
   else
   {bukan di area gambar}
   begin
     SetViewPort(0,0,getmaxx,getmaxy,true);
     SetLineStyle(0, 0, 1);
     {memilih menu samping}
     for i := 1 to 4 do
     begin
         if mouseinkotak(10,80+(i*20),35,100+(i*20)-1) then
         begin
              setwritemode(copyput);
              mouseoff;
              kotak(10,80+(menu_s*20),35,100+(menu_s*20)-1,0,0,false); {hapus kotak kuning dignati jadi kotak hitam}
              mouseon;
              menu_s := i;  {aksi yang dipilih}
              break;  {keluar dari for agar tidak terjadi pengulangan 2 x atau lebih}
         end;
     end;
     if mouseinkotak(10,80+(menu_s*20),35,100+(menu_s*20)-1) then

     mouseoff;
     kotak(10,80+(menu_s*20),35,100+(menu_s*20)-1,14,14,false);{gambar kotak kuning di menu samping}
     mouseon;
     {pilih warna}
     for i := 0 to 15 do
     if mouseinkotak(100+(i*20),455,120+(i*20)-1,475) then
     begin
          setwritemode(copyput);
          if klik = kiri then
          begin
          mouseoff;
          kotak(100+(menu_b*20),455,120+(menu_b*20)-1,475,0,0,false);{kotak hitam untuk menutupi kotak kuning sebelumnya}
          mouseon;
          menu_b := i; {warna pinggir}
          end
          else
          warna_f := i; {warna floodfill}
          break;
     end;
     if klik = kiri then
     begin
     mouseoff;
     kotak(100+(menu_b*20),455,120+(menu_b*20)-1,475,14,14,false);{gambar kotak kuning di menu bawah}
     mouseon;
     setcolor(menu_b);
     end;
     mouseoff;
     kotak(5,455,45,475,menu_b,warna_f,true);{gambar kotak kiri bawah}
     mouseon;
     {pilih jenis garis}
     for i := 0 to 2 do
     begin
         if mouseinkotak(10,300+(i*20),35,320+(i*20)-1) then
         begin
              mouseoff;
              kotak(10,300+(menu_g*20),35,320+(menu_g*20)-1,0,0,false) ;
              menu_g := i; {jemis garis}
              mouseon;
              break;
         end;
     end;
     mouseoff;
     kotak(10,300+(menu_g*20),35,320+(menu_g*20)-1,14,14,false) ;
     mouseon;
     {pilih ketebalan garis 1/3}
     for i := 0 to 1 do
     begin
          if mouseinkotak(10,400+(i*20),35,420+(i*20)-1) then
          begin
               mouseoff;
               if tebal_g = 1 then tebal_g := 0
               else
                   tebal_g := 1;

               kotak(10,400+(tebal_g*20),35,420+(tebal_g*20)-1,0,0,false);{kotak hitam}
               tebal_g := 1 + 2*i; {tebal garis hanya 1 dan 3}
               mouseon;
               break;
          end;
     end;
     mouseoff;
     if tebal_g = 1 then i := 0
     else
        i := 1;
     kotak(10,400+(i*20),35,420+(i*20)-1,14,14,false);{kotak kuning}
     setcolor(menu_b);

     mouseon;
     repeat
           mouselepas(klik); {tunggu sampai mouse dilepas}
     until tikus.tombolmana<>0; {ada mouse dilepas}

   end;
   until mouseinkotak(615,5,635,25); {exit}

end;
procedure programpaint;
begin
     bukagraph; {membuka mode graph 640x480}
     kotak_menu; {gambar awal}
     proses;     {proses yang terjadai}
end;
end.