unit game ;
interface
uses crt,dos ;
const screen : pointer = ptr($A000,0) ;
   procedure malloc(var buff:pointer;size:word) ;
   procedure close_graph ;
   procedure grapic ;
   procedure put_piksel(var buff; x,y,col:integer) ;
   procedure bola(var buff;x,y,r,war :integer) ;
   procedure box(var buff;x,y,pjg,lbr,war : integer) ;
   procedure clean(var buff);
   procedure copy(var source,dest);
   procedure assign(var op;nilai : byte) ;
   procedure tambah(var op) ;
   function  presskey:byte ;
   function  sudut(speed : byte):integer ;
   function  banding(op1:integer;opr:char;op2 : integer):boolean ;
   function  take(var op):byte ;

implementation
   procedure malloc(var buff:pointer;size:word) ;
   begin
        getmem(buff,size) ;
   end ;
   procedure close_graph ; assembler ;
   asm
      mov ax,3
      int 10h
   end ;
   procedure grapic ;assembler ;
   asm
       mov ax,13h
       int 10h
   end ;


    procedure put_piksel(var buff; x,y,col:integer) ;assembler ;
    asm
       push ds
       les di,buff
       mov dx,x
       mov di,dx
       mov ax,y
       mov bx,320
       mul bx
       add di,ax
       mov ax,col
       stosb
       pop ds
    end ;

    procedure bola(var buff;x,y,r,war :integer) ;
    var i,j : integer ;
    begin
         for j := 0 to 400 do
              put_piksel(buff,x+round(r*cos(j*pi/200)),y+round(r*sin(j*pi/200)),war) ;
    end ;

    procedure box(var buff;x,y,pjg,lbr,war : integer) ;
    var i : integer ;
    begin
         for i := 0 to pjg do
         begin
             put_piksel(buff,x+i,y,war) ;
             put_piksel(buff,x+i,y+lbr,war) ;
         end ;
         for i := 0 to lbr do
         begin
             put_piksel(buff,x,y+i,war) ;
             put_piksel(buff,x+pjg,y+i,war) ;
         end ;
    end ;

    procedure clean(var buff); assembler ;
    asm
       push ds
       mov cx,32000
       les di,buff
       mov ax,0;
       rep stosw
       pop ds
    end ;

    procedure copy(var source,dest); assembler ;
    asm
       push ds
       les di,dest
       lds si,source
       mov cx,32000
       rep movsw
       pop ds
    end ;

    procedure assign(var op;nilai : byte) ;assembler ;
    asm
       push ds
       les di,op
       mov bl,nilai
       mov byte ptr[di],bl
       pop ds
    end ;

    procedure tambah(var op) ; assembler ;
    asm
       push ds
       les di,op
       mov bl,[di]
       inc bl
       mov [di],bl
       pop ds
    end ;

    function presskey:byte ;
    var key : byte ;
    begin
       asm
          push ds
          mov ah,0
          int 16h
          mov key,ah
          pop ds
       end ;
       presskey := key ;
    end ;

    function  banding(op1: integer;opr:char;op2 : integer):boolean ;
    var bool : byte ;
    begin
         asm
            push ds
            mov al,0
            mov bx,op1
            mov cx,op2
            mov ah,opr
            cmp ah,">"
            je @g
            cmp ah,"<"
            je @l
            cmp ah,"="
            je @e
            jmp @end
            @true :mov al,1;
                   jmp @end ;

            @g:cmp bx,cx
               jg @true
               jmp @end

            @l:cmp bx,cx
               jl @true
               jmp @end

            @e:cmp bx,cx
               je @true

            @end:mov bool,al
            pop ds
         end ;
         if bool = 1 then banding := true else banding := false ;

    end ;

    function take(var op) : byte ;
    var temp : byte ;
    begin
         asm
            push ds
            les di,op
            mov bl,[di]
            mov temp,bl
            pop ds
         end ;
         take := temp ;
    end ;

    function sudut(speed :byte):integer ;
    begin
         randomize ;
         sudut := random(random(4))+speed ;
    end ;



end.